<?php
/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/


define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/mtf-classes.'.$phpEx);


$page_title = 'MTF';
$VARS = @array_merge($HTTP_GET_VARS, $_GET, $HTTP_POST_VARS, $_POST);
if (!isset($_FILES)) {
	$_FILES = &$HTTP_POST_FILES;
}
$files = isset($VARS['files'])?$VARS['files']:false;
if (isset($VARS['delete'])) {
	$mode = 'delete';
} elseif (isset($VARS['confirmdelete'])) {
	$mode = 'confirmdelete';
} elseif (isset($_FILES['mtffile'])) {
	$mode = 'send';
} elseif (isset($VARS['sync'])) {
	$mode = 'sync';
} else {
	$mode = 'list';
}


//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//


//
// Configuration
//
define('MTF_PATH', dirname(__FILE__) . '/mtf');
define('USER_MOD_ALLOWED', $userdata['user_level']>=ADMIN);
define('MTF_FILENAME_MATCH', '/[a-zA-Z0-9_\-]/');
define('PAGE_URL', "http://" . $_SERVER['SERVER_NAME'] . 
	dirname($_SERVER['REQUEST_URI']) . "/");



function update_mtf($path, $filename, $die = true) {
	GLOBAL $db;

	//
	// Ckeck filename
	//
	if (substr($filename, -4)!='.mtf' || !preg_match(MTF_FILENAME_MATCH, substr($filename, 0, -4)))
	{
		echo("(!!) Wrong filename\n");
		return false;
	}


	//
	// Parse
	//
	$filename = substr($filename, 0, -4);
	$mtf = &new MTFPart();
	$authors = &new MTFAuthorsSet();
	$result = $mtf->parseFile($path, $authors);


	//
	// Check
	//
	if ($mtf->getName()===null) {
		echo("(!!) #name required\n");
		return false;
	}
	if ($mtf->getType()==0 && $filename!='main') {
		echo("(!!) Main MTF must be named 'main.mtf'\n");
		return false;
	} elseif ($mtf->getType()!=0 && $filename=='main') {
		echo("(!!) Only main MTF can be named 'main.mtf'\n");
		return false;
	}
	if (!$result) {
		return false;
	}
	$fname = "'" . addslashes($filename) . "'";


	//
	// Get count
	//
	$sql = "SELECT COUNT(*) AS count FROM mtf_files
		WHERE mtf_filename=$fname
		GROUP BY mtf_filename";
	$result = $db->sql_query($sql);
	if (!$result) {
		echo("(!!) SQL Faild: Could not get MTF file information\n");
		return false;
	}
	$count = $db->sql_fetchrow($result);
	$count = $count['count'];


	//
	// Init query
	//
	$name = $mtf->getName();
	$version = $mtf->getVersion();
	$version = $version===null?'NULL':("'" . addslashes($version) . "'");
	$name = "'" . addslashes($name) . "'";
	$type = intval($mtf->getType());
	$author = '';
	for ($i = 0; $i<$mtf->authors->count(); ++$i) {
		$a = &$mtf->authors->get($i);
		$author .= ($author==''?'':', ') . $a->getName();
	}
	$author = $author==''?'NULL':("'" . addslashes($author) . "'");
	$ctime = intval($mtf->getCTime());
	$mtime = intval($mtf->getMTime());


	//
	// Create query
	//
	if ($count) {
		$sql = "UPDATE mtf_files
		SET
			mtf_type=$type,
			mtf_name=$name,
			mtf_version=$version,
			mtf_author=$author,
			mtf_ctime=$ctime,
			mtf_mtime=$mtime
		WHERE
			mtf_filename=$fname";
	} else {
		$sql = "INSERT INTO mtf_files
			(mtf_filename, mtf_name, mtf_version, mtf_type, mtf_author, mtf_ctime, mtf_mtime)
		VALUES ($fname, $name, $version, $type, $author, $ctime, $mtime)";
	}


	//
	// Query
	//
	$result = $db->sql_query($sql);
	if (!$result)
	{
		echo("(!!) SQL Faild: Could not update/create record\n");
		return false;
	}


	//
	// Update file
	//
	if (!rename($path, MTF_PATH . "/$filename.mtf"))
	{
		echo("(!!) Could not write MTF file\n");
		return false;
	}
	chmod(MTF_PATH . "/$filename.mtf", 0755);

	echo("(++) $filename updated.\n");
	return true;
}


//
// Generate 
//
if ( $mode=='list' && $files )
{
	sleep(2);
	header('Content-Type: text/plain');
	$arr = array();
	foreach ($files AS $i => $file) {
		if (preg_match(MTF_FILENAME_MATCH, $file)) {
			$arr[] = MTF_PATH . "/$file.mtf";
		}
	}

	$mtfs = &new MTFPartsSet();
	ob_start();
	$mtfs->parseFiles($arr);
	ob_end_clean();
	$printer = &new MTFPrinter(0, null,
		"This file was generated using MTF Parser by
		Michal Nazarewicz (mina86@tlen.pl) running at " . PAGE_URL .
		"\nAny comments are welcome.");
	$printer->printAll($mtfs);
	die();
}


//
// Delete or edit
//
if ($mode!='list') {
	// Not MOD?
	if ( !USER_MOD_ALLOWED ) {
		message_die(GENERAL_MESSAGE, $lang['Not_Moderator'], $lang['Not_Authorised']);
	}

	// None?
	if ($mode!='send' && ($files===false || count($files)===0)) {
		message_die(GENERAL_MESSAGE, $lang['None_MTF_selected']);
	}


	//
	// Show confirm dialog
	//
	if ($mode=='delete') {
		$hidden_fields = '<input type="hidden" name="sid" value="' . $userdata['session_id'] . '" /><input type="hidden" name="confirmdelete" value="yes" />';
		for ($i = 0; $i<count($files); ++$i) {
			$hidden_fields .= '<input type="hidden" name="files[]" value="' . $files[$i] . '" />';
		}

		//
		// Set template files
		//
		$template->set_filenames(array(
			'confirm' => 'confirm_body.tpl')
		);

		$template->assign_vars(array(
			'MESSAGE_TITLE' => $lang['Confirm'],
			'MESSAGE_TEXT' => $lang['Confirm_delete_MTF'],

			'L_YES' => $lang['Yes'],
			'L_NO' => $lang['No'],

			'S_CONFIRM_ACTION' => append_sid("mtf.$phpEx"),
			'S_HIDDEN_FIELDS' => $hidden_fields)
		);


		include($phpbb_root_path . 'includes/page_header.'.$phpEx);
		$template->pparse('confirm');
		include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
		die();
	}


	//
	// Delete
	//
	if ($mode=='confirmdelete') {
		$files2 = array();
		for ($i = 0; $i<count($files); ++$i) {
			$files2[] = "'" . addslashes($files[$i]) . "'";
		}
		$sql = "DELETE FROM mtf_files WHERE mtf_filename IN (" . implode(', ', $files2) . ") AND (mtf_type!=0)";
		if( !$db->sql_query($sql) )
		{
			message_die(GENERAL_ERROR, 'Could not delete MTF files list', '', __LINE__, __FILE__, $sql);
		}
		for ($i = 0; $i<count($files); ++$i) {
			$filename = $files[$i];
			if ($filename=='main') {
				continue;
			}
			rename(MTF_PATH . "/$filename.mtf", MTF_PATH . "/$filename.mtf~");
		}
		message_die(GENERAL_MESSAGE, $lang['MTF_Removed'] . '<br /><br />' . $l_redirect);
	}


	//
	// Update MTF File
	//
	if ($mode=='send') {
		// Read data
		$file = &$_FILES['mtffile'];
		$filename = strtolower($file['name']);

		if (!is_uploaded_file($file['tmp_name'])) {
			message_die(GENERAL_ERROR, 'Unexpected error', '', __LINE__, __FILE__);
		}

		header('Content-Type: text/html');
		update_mtf($file['tmp_name'], $filename);
		die();
	}


	//
	// Sync
	//
	if ($mode=='sync') {
		$dir = opendir(MTF_PATH);
		$arr = array();
		while (($filename = readdir($dir))!==false) {
			if (substr($filename, -4)=='.mtf' && preg_match(MTF_FILENAME_MATCH, substr($filename, 0, -4))) {
				$arr[] = $filename;
			}
		}
		closedir($dir);

		header('Content-Type: text/plain');
		$num = count($arr);
		$ok = 0;
		for ($i = 0; $i<count($arr); ++$i) {
			$filename = $arr[$i];
			echo("===> $filename <===\n");
			if (update_mtf(MTF_PATH . "/$filename", strtolower($filename))) {
				++$ok;
			}
			echo("\n\n\n");
		}
		echo("$ok out of $num files succesfully updated.\n");
		die();
	}
}




//
// Create Order string
//
$order = isset($VARS['o'])?$VARS['o']:'name';
if (substr($order, 0, 1)=='-') {
	$desc = ' DESC';
	$order = substr($order, 1);
} else {
	$desc = '';
}
if ($order!='name' && $order!='mtime' && $order!='author' && $order!='ctime' && $order!='version') {
	$order = 'name';
	$desc = '';
}


//
// Query MTF File list
//
$sql = "SELECT * FROM mtf_files  ORDER BY mtf_$order$desc";
if( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Could not query MTF files list', '', __LINE__, __FILE__, $sql);
}


//
// Okay, let's build the index
//
$parts = array(array(), array(), array());
while( $mtf = $db->sql_fetchrow($result) )
{
	$parts[$mtf['mtf_type']][] = $mtf;
}

$names = array('Main', 'Protocols', 'Plugins');
for ($i = 0; $i<3; ++$i) {
	$mtfs = &$parts[$i];
	if (count($mtfs)==0) {
		continue;
	}
	$template->assign_block_vars('catrow', array(
		'NAME' => $names[$i]
	));
	$template->assign_block_vars('catrow.is' . ($i==0?'':'_not') . '_main', array());
	$itype = $i?'checkbox':'hidden';

	for ($j = 0; $j<count($mtfs);) {
		$mtf = &$mtfs[$j++];
		$template->assign_block_vars('catrow.partrow', array(
			'NUM' => $i==0?'':"$j.",
			'NAME' => $mtf['mtf_name'],
			'VERSION' => $mtf['mtf_version'],
			'FILENAME' => $mtf['mtf_filename'],
			'CTIME' => $mtf['mtf_ctime']?create_date($board_config['default_dateformat'], $mtf['mtf_ctime'], $board_config['board_timezone']):'',
			'MTIME' => $mtf['mtf_mtime']?create_date($board_config['default_dateformat'], $mtf['mtf_mtime'], $board_config['board_timezone']):'',
			'AUTHOR' => $mtf['mtf_author'],
			'ITYPE' => $itype,

			'U_MTF' => 'mtf/' . $mtf['mtf_filename'] . '.mtf',
		));
	}
}


//
// Generate the page
//
$template->set_filenames(array(
	'body' => 'mtf_list.tpl')
);

$template->assign_vars(array(
	'L_NAME' => $lang['MTF_Name'],
	'L_VERSION' => $lang['MTF_Version'],
	'L_AUTHOR' => $lang['Author'],
	'L_CTIME' => $lang['MTF_CTime'],
	'L_MTIME' => $lang['MTF_MTime'],
	'L_DOWNLOAD' => $lang['MTF_Download'],
	'L_DELETE' => $lang['MTF_Delete'],
	'L_UPLOAD' => $lang['MTF_Upload'],
	'L_SYNC_WITH_DIR' => $lang['MTF_Sync_with_dir'],
	'L_SORT_A' => $lang['Sort_A'],
	'L_SORT_D' => $lang['Sort_D'],

	'U_SORT_NAME_ASC' => append_sid("mtf.$phpEx?o=name"),
	'U_SORT_NAME_DESC' => append_sid("mtf.$phpEx?o=-name"),
	'U_SORT_VERSION_ASC' => append_sid("mtf.$phpEx?o=version"),
	'U_SORT_VERSION_DESC' => append_sid("mtf.$phpEx?o=-version"),
	'U_SORT_CTIME_ASC' => append_sid("mtf.$phpEx?o=ctime"),
	'U_SORT_CTIME_DESC' => append_sid("mtf.$phpEx?o=-ctime"),
	'U_SORT_MTIME_ASC' => append_sid("mtf.$phpEx?o=mtime"),
	'U_SORT_MTIME_DESC' => append_sid("mtf.$phpEx?o=-mtime"),
	'U_SORT_AUTHOR_ASC' => append_sid("mtf.$phpEx?o=author"),
	'U_SORT_AUTHOR_DESC' => append_sid("mtf.$phpEx?o=-author"),
	'U_ACTION' => append_sid('mtf.php')
));


//
// Is MOD
//
if ( USER_MOD_ALLOWED )
{
	$template->assign_block_vars('switch_user_mod', array());
	$template->assign_vars(array(
		'L_MTF_DELETE' => $lang['MTF_Delete'],
		'L_MTF_EDIT' => $lang['MTF_Edit']
	));
}



//
// Output the page
//
include($phpbb_root_path . 'includes/page_header.'.$phpEx);
$template->pparse('body');
include($phpbb_root_path . 'includes/page_tail.'.$phpEx);
?>
